#line 1 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha2_routines.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/hashes/sha2_routines.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 54 "e:/git/secure_7_click/secure_7_click/sw/library/cryptoauthlib/crypto/hashes/sha2_routines.h"
typedef struct {
 uint32_t total_msg_size;
 uint32_t block_size;
 uint8_t block[ (64)  * 2];
 uint32_t hash[8];
} sw_sha256_ctx;

void sw_sha256_init(sw_sha256_ctx* ctx);

void sw_sha256_update(sw_sha256_ctx* ctx, uint8_t* message, uint32_t len);

void sw_sha256_final(sw_sha256_ctx * ctx, uint8_t digest[ (32) ]);

void sw_sha256( uint8_t * message, unsigned int len, uint8_t digest[ (32) ]);
#line 54 "E:/git/Secure_7_Click/Secure_7_Click/SW/library/cryptoauthlib/crypto/hashes/sha2_routines.c"
static void sw_sha256_process(sw_sha256_ctx* ctx, uint8_t* blocks, uint32_t block_count)
{
 int i = 0;
 uint32_t block = 0;

 union {
 uint32_t w_word[ (64) ];
 uint8_t w_byte[ (64)  * sizeof(uint32_t)];
 } w_union;

 static uint32_t k[] = {
 0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5, 0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
 0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3, 0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
 0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc, 0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
 0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7, 0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
 0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13, 0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
 0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3, 0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
 0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5, 0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
 0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208, 0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
 };


 for (block = 0; block < block_count; block++) {
 uint32_t w_index;
 uint32_t word_value;
 uint32_t s0, s1;
 uint32_t t1, t2;
 uint32_t maj, ch;
 uint32_t rotate_register[8];
 uint8_t* cur_msg_block = &blocks[block *  (64) ];


 for (i = 0; i <  (64) ; i += 4) {
 w_union.w_byte[i + 3] = cur_msg_block[i + 0];
 w_union.w_byte[i + 2] = cur_msg_block[i + 1];
 w_union.w_byte[i + 1] = cur_msg_block[i + 2];
 w_union.w_byte[i + 0] = cur_msg_block[i + 3];
 }

 w_index = 16;
 while (w_index <  (64) ) {

 word_value = w_union.w_word[w_index - 15];
 s0 =  ((word_value >> 7) | (word_value << (32 - 7)))  ^  ((word_value >> 18) | (word_value << (32 - 18)))  ^ (word_value >> 3);

 word_value = w_union.w_word[w_index - 2];
 s1 =  ((word_value >> 17) | (word_value << (32 - 17)))  ^  ((word_value >> 19) | (word_value << (32 - 19)))  ^ (word_value >> 10);

 w_union.w_word[w_index] = w_union.w_word[w_index - 16] + s0 + w_union.w_word[w_index - 7] + s1;

 w_index++;
 }


 for (i = 0; i < 8; i++)
 rotate_register[i] = ctx->hash[i];


 for (i = 0; i <  (64) ; i++) {
 s0 =  ((rotate_register[0] >> 2) | (rotate_register[0] << (32 - 2))) 
 ^  ((rotate_register[0] >> 13) | (rotate_register[0] << (32 - 13))) 
 ^  ((rotate_register[0] >> 22) | (rotate_register[0] << (32 - 22))) ;
 maj = (rotate_register[0] & rotate_register[1])
 ^ (rotate_register[0] & rotate_register[2])
 ^ (rotate_register[1] & rotate_register[2]);
 t2 = s0 + maj;
 s1 =  ((rotate_register[4] >> 6) | (rotate_register[4] << (32 - 6))) 
 ^  ((rotate_register[4] >> 11) | (rotate_register[4] << (32 - 11))) 
 ^  ((rotate_register[4] >> 25) | (rotate_register[4] << (32 - 25))) ;
 ch = (rotate_register[4] & rotate_register[5])
 ^ (~rotate_register[4] & rotate_register[6]);
 t1 = rotate_register[7] + s1 + ch + k[i] + w_union.w_word[i];

 rotate_register[7] = rotate_register[6];
 rotate_register[6] = rotate_register[5];
 rotate_register[5] = rotate_register[4];
 rotate_register[4] = rotate_register[3] + t1;
 rotate_register[3] = rotate_register[2];
 rotate_register[2] = rotate_register[1];
 rotate_register[1] = rotate_register[0];
 rotate_register[0] = t1 + t2;
 }


 for (i = 0; i < 8; i++)
 ctx->hash[i] += rotate_register[i];
 }
}

void sw_sha256_init(sw_sha256_ctx* ctx)
{
 static uint32_t hash_init[] = {
 0x6a09e667, 0xbb67ae85, 0x3c6ef372, 0xa54ff53a,
 0x510e527f, 0x9b05688c, 0x1f83d9ab, 0x5be0cd19
 };
 int i;

 memset(ctx, 0, sizeof(*ctx));
 for (i = 0; i < 8; i++)
 ctx->hash[i] = hash_init[i];
}

void sw_sha256_update(sw_sha256_ctx* ctx, uint8_t* msg, uint32_t msg_size)
{
 uint32_t block_count;
 uint32_t rem_size =  (64)  - ctx->block_size;
 uint32_t copy_size = msg_size > rem_size ? rem_size : msg_size;


 memcpy(&ctx->block[ctx->block_size], msg, copy_size);

 if (ctx->block_size + msg_size <  (64) ) {

 ctx->block_size += msg_size;
 return;
 }


 sw_sha256_process(ctx, ctx->block, 1);


 msg_size -= copy_size;
 block_count = msg_size /  (64) ;
 sw_sha256_process(ctx, &msg[copy_size], block_count);


 ctx->total_msg_size += (block_count + 1) *  (64) ;
 ctx->block_size = msg_size %  (64) ;
 memcpy(ctx->block, &msg[copy_size + block_count *  (64) ], ctx->block_size);
}

void sw_sha256_final(sw_sha256_ctx* ctx, uint8_t digest[ (32) ])
{
 int i, j;
 uint32_t msg_size_bits;
 uint32_t pad_zero_count;


 ctx->total_msg_size += ctx->block_size;
 msg_size_bits = ctx->total_msg_size * 8;


 pad_zero_count = ( (64)  - ((ctx->block_size + 9) %  (64) )) %  (64) ;


 ctx->block[ctx->block_size++] = 0x80;


 memset(&ctx->block[ctx->block_size], 0, pad_zero_count + 4);
 ctx->block_size += pad_zero_count + 4;



 ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 24);
 ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 16);
 ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 8);
 ctx->block[ctx->block_size++] = (uint8_t)(msg_size_bits >> 0);

 sw_sha256_process(ctx, ctx->block, ctx->block_size /  (64) );



 for (i = 0; i < 8; i++)
 for (j = sizeof(int32_t) - 1; j >= 0; j--, ctx->hash[i] >>= 8)
 digest[i * sizeof(int32_t) + j] = ctx->hash[i] & 0xFF;
}

void sw_sha256( uint8_t* message, unsigned int len, uint8_t digest[ (32) ])
{
 sw_sha256_ctx ctx;

 sw_sha256_init(&ctx);
 sw_sha256_update(&ctx, message, len);
 sw_sha256_final(&ctx, digest);
}
